
// WinWolDlg.h : wb_[ t@C
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "CollectProcDlg.h"

#define	WM_WOL_WIN_MSG		(WM_USER + 200)

#define	TIMER_ID_GENERAL	(1)
#define	TIMER_ID_REFRESH	(2)
#define	TIMER_ID_TIPS		(3)

#define	TIP_DISP_TIMEOUT	(5)		//bŎw

#define	LIST_ROW_HEIGHT		(20)
#define	LIST_ICON_WIDTH		(16)
#define	LIST_ICON_HEIGHT	(16)

#define	DEFAULT_ACTIVE_MARK	" * "
#define	BMP_FILE_ACTIVE		"active.bmp"
#define	BMP_FILE_INACTIVE	"inactive.bmp"
#define INACTIVE_IMAGE_IDX	(1)
#define ACTIVE_IMAGE_IDX	(2)

enum _ListItemIdx {
	LIST_ITEM_ACTIVE=0,
	LIST_ITEM_HOST_NAME,
	LIST_ITEM_COMMENT,
	LIST_ITEM_IP_ADDR,
	LIST_ITEM_NET_MASK,
	LIST_ITEM_MAC_ADDR,
	LIST_ITEM_NUM
};

enum {
	WOL_MSG_NONE = 0,
	WOL_MSG_REPAINT = 1,
	WOL_MSG_COL_WIDTH_CHANGE,
	WOL_MSG_COLLECT_HOST,
	WOL_MSG_DETECT_HOST,
	WOL_MSG_COLLECT_MSG,
	WOL_MSG_CLEAR_STATUS,
	WOL_WIN_MSG_NUM
};

enum {
	WOL_CURSOR_TYPE_NORMAL = 0,
	WOL_CURSOR_TYPE_WAIT,
	WOL_CURSOR_TYPE_WAIT_ARROW,
	WOL_CURSOR_TYPE_NUM
};

typedef struct {
	int			active;
	char		hostname[128];
	char		comment[128];
	char		ipaddr[32];
	char		netmask[32];
	char		macaddr[32];
} tHostInfo;

// CWinWolDlg _CAO
class CWinWolDlg : public CDialogEx
{
// RXgNV
public:
	CWinWolDlg(CWnd* pParent = NULL);	// WRXgN^[

	// ICMPpPbg̑M
	BOOL	SendIcmpPacket(LPCTSTR sHost);

	DWORD	GetCollectStartAddr(void) {
		return m_dwCollectStartAddr;
	}
	DWORD	GetCollectEndAddr(void) {
		return m_dwCollectEndAddr;
	}
	DWORD	GetCollectNetMask(void) {
		return m_dwCollectNetMask;
	}
	DWORD	GetCollectCurrentAddr(void) {
		return m_dwCollectCurrentAddr;
	}

// _CAO f[^
	enum { IDD = IDD_WINWOL_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g

// 
protected:
	HICON		m_hIcon;
	HACCEL		m_Accel;

	CString		m_IniFileName;
	CString		m_sModuleDir;

	CString		m_SelHostName;
	CString		m_SelComment;
	CString		m_SelMacAddr;
	CString		m_SelIpAddr;
	CString		m_SelNetMask;

	UINT		m_TimeOut;
	UINT		m_CollectHostTimeOut;
	CString		m_sCollectHostStart;
	CString		m_sCollectHostEnd;
	CString		m_sCollectHostNetMask;
	UINT		m_PortNo;
	UINT		m_MaxHostNum;
	BOOL		m_bInitRefresh;
	BOOL		m_bNoExternCmd;
	BOOL		m_bCheckNetworkSegment;
	BOOL		m_bAutoRefresh;
	BOOL		m_bEnableRemoteShutdown;
	UINT		m_TimerInterval;
	UINT		m_nColWidth[LIST_ITEM_NUM];

	UINT_PTR	m_TimerID;
	UINT_PTR	m_RefreshTimerID;
	UINT_PTR	m_TipTimerID;
	int			m_nTipTimeOut;
	int			m_ListIndex;
	BOOL		m_bInited;
	HANDLE		m_hWorkEvent;
	HANDLE		m_hWorkThread;
	BOOL		m_bWorkActive;
	BOOL		m_bWorkBusy;

	CToolBar	m_wndToolBar;
	CStatusBar	m_wndStatusBar;
	CImageList	m_ImgList;
	COLORREF	m_ActiveBgColor;
	COLORREF	m_ActiveFgColor;
	COLORREF	m_ActiveImgMaskColor;
	UINT		m_nActiveMarkType;
	UINT		m_ListRowHeight;
	CString		m_sAvtiveMark;
	CImageList	m_ImageListStatus;

	int			m_nCursorType;
	HANDLE		m_hCollectThread;
	HANDLE		m_hCollectEvent;

	DWORD		m_dwCollectStartAddr;
	DWORD		m_dwCollectEndAddr;
	DWORD		m_dwCollectNetMask;
	DWORD		m_dwCollectCurrentAddr;
	int			m_nCollectDetectCount;
	BOOL		m_bCollectActive;

	CCollectProcDlg		*m_pCollectProcDlg;
	CRITICAL_SECTION	m_csCollect;
	CRITICAL_SECTION	m_csRefresh;
	CRITICAL_SECTION	m_csListItem;

	CArray<tHostInfo>	m_HostArray;

	//Xe[^Xo[ɃbZ[W\
	void	DispStatusMsg(LPCTSTR lpMsg);

	//j[獀ڂ̈ʒu擾
	int		SearchMenuPos(CMenu *pMenu, UINT nID);

	//c[o[̕\XV
	void	ToolBarItemEnable();

	// }WbNEpPbgM
	int		SendMagicPacket(LPCTSTR sIpAddr, LPCTSTR sNetMask, LPCTSTR sMacAddr, BOOL bBloadcast=TRUE);

	//wzXg̋N󋵂`FbN
	BOOL	CheckAliveHost(SOCKET sock, int idx);

	void	ShutDownWindowsHost(int idx);

	void	SetAliveMark(int idx);

	void	RefreshAliveMark(int idx);

	//Xg̃zXgN󋵂XV
	void	RefreshAliveHost(int idx);

	//zXgҏW
	BOOL	EditHost(int idx);

	void	ListItemUp(int idx);

	void	ListItemDown(int idx);

	void	LoadIniFile(void);

	void	SaveIniFile(void);

	void	InitDialog(void);

	void	RefreshHostList(void);				//zXgꗗɃzXgZbg

	void	ChangeActiveIconType(int Type);

	void	RefreshActiveIconIndent(void);

	void	RefreshStart(BOOL bShowStatus = TRUE);

	BOOL	SetRegistory(void);

	BOOL	SendMagicPacketToListItem(int item, bool bBloadcast=TRUE);

	void	WakeupHosts(bool bBloadcast);

	void	EnableAutoRefresh(BOOL bEnable);			//XV̗L^

	void	SetCollectActiveFlag(BOOL bFlag) {
		EnterCriticalSection(&m_csCollect);
		m_bCollectActive = bFlag;
		LeaveCriticalSection(&m_csCollect);
	}
	BOOL	GetCollectActiveFlag(void) {
		BOOL	bFlag;
		EnterCriticalSection(&m_csCollect);
		bFlag = m_bCollectActive;
		LeaveCriticalSection(&m_csCollect);
		return bFlag;
	}

	//zXgW
	void	CollectHostInfo(DWORD dwStartAddr, DWORD dwEndAddr,
									DWORD dwNetMask, UINT nTimeOut);

	DWORD	WorkThreadProc(void);						//ғ󋵍XVXbh̏֐

	DWORD	CollectThreadProc(void);					//zXgWXbh̏֐

	//ғ󋵍XVXbh֐
	static DWORD WINAPI	WorkThreadFunc(PVOID pArg) {
		//ғ󋵍XVXbh̏s
		return ((CWinWolDlg*)pArg)->WorkThreadProc();
	}

	//zXgWXbh֐
	static DWORD WINAPI	CollectThreadFunc(PVOID pArg) {
		//zXgWXbh̏s
		return ((CWinWolDlg*)pArg)->CollectThreadProc();
	}

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();

	DECLARE_MESSAGE_MAP()

public:
	CListCtrl	m_ListHosts;

	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	afx_msg void OnLvnGetInfoTipListHost(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedListHost(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMDblclkListHost(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRClickListHost(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnAppExit();
	afx_msg void OnEditAppend();
	afx_msg void OnEditInsert();
	afx_msg void OnEditEdit();
	afx_msg void OnEditDelete();
	afx_msg void OnViewRefresh();
	afx_msg void OnToolSend();
	afx_msg void OnToolSendNonBloadcast();
	afx_msg void OnToolOption();
	afx_msg void OnToolGetIpAddr();
	afx_msg void OnToolGetMacAddr();
	afx_msg void OnToolGetHost();
	afx_msg void OnViewCheck();
	afx_msg void OnViewPeriodStart();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnViewPeriodStop();
//	afx_msg void OnToolRegChange();
	afx_msg void OnToolSendIcmp();
	afx_msg void OnNMCustomdrawListHost(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnToolShutdown();
	afx_msg LRESULT	OnWakeOnLanWinMsg(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT	OnCollectProcMsg(WPARAM wParam, LPARAM lParam);
	afx_msg void OnToolCollectHostInfo();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnEditUp();
	afx_msg void OnEditDown();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditCut();
	afx_msg void OnEditSelectAll();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
};
